config/routes.rb
Rails.application.routes.draw do
  root to: 'dashboard#show'
  get 'locked' => 'pages#locked', as: :locked_screen
  get 'thankyou' => 'pages#thankyou', as: :thankyou_screen

  devise_for :staffs
  devise_for :users

  resources :tickets do
    member do
      put :feedback_submit
    end
    collection do
      get :search
    end
    resources :comments
  end

  resources :todos
  resources :products do
    collection do
        get :search
      end
  end
  resources :quotes
  resource :account, controller: :account
  resource :staff_account, controller: :staff_account
  resources :notifications do
    collection do
      put :mark_as_read
    end
  end

  namespace :manager do
    resource :dashboard, controller: :dashboard do
      collection do
        get :chart_data
      end
    end
    resources :users
  end
 

  namespace :admin do
    resources :staffs
    
  end

  namespace :guest do
    resources :tickets
  end
  
  namespace :staff do
    resources :quotes do
      member do
        post :create_ticket
      end
    end



    resource :dashboard, controller: :dashboard do
      collection do
        get :chart_data
      end
    end
    resources :tickets do
      member do
        put :feedback_submit
      end
      collection do
        get :search
      end
    end
    resources :clients do
      resources :users do
      collection do
        get :search
      end
    end
 
    end
  end

end

app/models/user.rb
class User < ApplicationRecord
  ROLES = { 'manager' => 'Manager', 'end_user' => 'User'}

  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable

  has_many :tickets
  has_many :quotes
  belongs_to :client
  has_many :todos, as: :creator
  has_many :comments, as: :creator
  has_many :notifications, as: :notifiable

  has_attached_file :photo, styles: { medium: "300x300>", thumb: "100x100>" }, default_url: "/images/:style/noimg.png"
  validates_attachment_content_type :photo, content_type: /\Aimage\/.*\z/
  
  validates :role, inclusion: ROLES.keys


  ROLES.each do |k, v|
    define_method "is_#{k}?" do
      role == k
    end
  end
end

app/controllers/manager/dashboard_controller.rb
class Manager::DashboardController < ApplicationController

  def show
    @todos = Todo.where(creator:  current_user, is_completed: false)
    @tickets =Ticket.joins(:user).where("users.client_id": current_user.client_id)
    @users = User.where(client_id: current_user.client_id)
  end

  def chart_data
    data = prepare_data(tickets_scope)
    colors = data_colors[0..data.count-1]

    op = {
      labels: data.keys,
      datasets: [{
        label: "Ticket Stats",
        data: data.values,
        backgroundColor: colors,
        hoverBackgroundColor: colors
      }]
    }

    render json: JSON.dump(op)
  end

  private
  def tickets_scope
    tickets = Ticket.joins(:user).where("users.client_id": current_user.client_id)
    tickets = case params[:filter]
    when 'open'
      tickets.open
    when 'in_progress'
      tickets.where(status: "in_progress")
    when 'all'
      Ticket.joins(:user).where("users.client_id": current_user.client_id)
    when 'unassigned'
      tickets.where(staff: nil)
    when 'closed'
      tickets.where(status: "closed")
    else
      tickets
    end

    tickets
  end

  def prepare_data(scope)
    op = {}
    Ticket::CATEGORIES.each do |c|
      count = scope.where(category: c).count
      op[c] = count if count > 0
    end
    if (count = scope.where('category IS NULL OR category NOT IN (?)', Ticket::CATEGORIES).count) > 0
      op['Others'] = count
    end

    op
  end

  def data_colors
    [
      "#222222",
      "#b8b8b8",
      "#00dac7",
      "#5C5C5C",
      "#ff5252",
      "#2196F3",
      "#4CAF50",
      "#FF0084",
      "#f57c00"
    ].shuffle
  end
  
end

app/controllers/manager/users_controller.rb
class Manager::UsersController < ApplicationController

  def new
    @user = User.new
  end

  def index
    @user = User.new
    @users = User.where(client_id: current_user.client_id, is_deleted: false).order(name: :asc)
  end

  def create
    @user = User.new(user_params)
    @user.client_id = current_user.client_id
    if @user.save
      redirect_to manager_users_path
    else
      render action: 'new'
    end
  end

  def edit
    @user = User.find(params[:id])
  end

  def update
    @user= User.find(params[:id])
    if @user.update_attributes(user_params)
      flash[:success]="Successfully updated"
      redirect_to manager_users_path()
    else
      render 'edit'
    end
  end

  def destroy
    @user= User.find(params[:id])
    @user.update_attributes is_deleted: true
    redirect_to manager_users_path
  end

  private
    def user_params
      params.require(:user).permit(:name, :email, :password, :password_confirmation, :role)
    end
    
end

app/controllers/staff/users_controller.rb
class Staff::UsersController < ApplicationController

  def new
    @user = User.new 
    @client= Client.find(params[:client_id])
  end

  def show
    @client= Client.find(params[:client_id])
    @user = User.find(params[:id])
  end

  def edit
    @user = User.find(params[:id])
    @client= Client.find(params[:client_id])
  end

  def update
    @client= Client.find(params[:client_id])
    @user= User.find(params[:id])
      if @user.update_attributes(user_params)
        flash[:success]="Successfully updated"
        redirect_to staff_client_user_path()
      else
        render 'edit'
    end
  end

  def create
    @client= Client.find(params[:client_id])
    @user = User.new(user_params)
    @user.client_id = @client.id
    if @user.save
      redirect_to staff_client_path(@client)
    else
      render action: 'new'
    end
  end

  def search
  @client= Client.find(params[:client_id])
  @users = User.where(client_id: @client.id)
  if params[:search][:query].present?
    query = '%' + params[:search][:query] + '%'
    @users = @users.where("name LIKE ? OR email LIKE ?", query, query)
  end
  render template: 'staff/clients/show'
  end

  def destroy
    @client= Client.find(params[:client_id])
    @user = User.find(params[:id])
    @user.is_deleted = true
    @user.save
    redirect_to staff_client_path(@client)
  end

  private
    def user_params
      op = params.require(:user).permit(:photo, :name, :email, :password, :password_confirmation, :role, :is_deleted)
      if op[:password].blank? and op[:password_confirmation].blank?
        op.delete :password
        op.delete :password_confirmation
      end
      return op
    end
    
end

app/helpers/admin/users_helper.rb
module Admin::UsersHelper
end

app/helpers/manager/dashboard_helper.rb
module Manager::DashboardHelper
end

app/helpers/manager/users_helper.rb
module Manager::UsersHelper
end

app/helpers/staff/users_helper.rb
module Staff::UsersHelper
end

app/views/manager/users/_new.html.erb
<div class="card-header">
<h5 class="card-header-text">New User</h5>
</div>
<%= form_for @user, url: manager_users_path , html: {class: "wizard clearfix"} do |f| %>

  <%= f.error_messages %>
  <div class="md-group-add-on">
  <span class="md-add-on">
  <i class="icofont icofont-ui-user"></i>
  </span>
  <div class="md-input-wrapper">
  <%=f.text_field :name, class: 'md-form-control' %>
  <%=f.label :name %>
  </div>
  </div>
  <div class="md-group-add-on">
    <span class="md-add-on">
      <i class="icofont icofont-ui-email"></i>
    </span>
    <div class="md-input-wrapper">
      <%=f.email_field :email, class: 'md-form-control' %>
      <%=f.label :email %>
    </div>
  </div>

  <div class="md-group-add-on">
    <span class="md-add-on">
      <i class="icofont icofont-ui-password"></i>
    </span>
    <div class="md-input-wrapper">
      <%=f.password_field :password, class: 'md-form-control' %>
      <%=f.label :password %>
    </div>
  </div>

  <div class="md-group-add-on">
    <span class="md-add-on">
      <i class="icofont icofont-key"></i>
    </span>
    <div class="md-input-wrapper">
      <%=f.password_field :password_confirmation, class: 'md-form-control' %>
      <%=f.label :"Re enter password" %>
    </div>
  </div>

  <div class="md-group-add-on">
    <span class="md-add-on">
      <i class="icofont icofont-funky-man"></i>
    </span>
    <div class="md-input-wrapper">
      <%=f.select :role, options_for_select(User::ROLES.collect{|k, v| [v, k]}, selected: f.object.role), {}, class: 'md-form-control md-static' %>
      <%=f.label :role %>
    </div>
  </div>

  <div class="text-center">
    <%= f.submit "create", class: "btn btn-primary" %>
    <%= link_to 'Cancel', manager_users_path, class: "btn btn-primary" %>
  </div>
<% end %>

app/views/manager/users/edit.html.erb
<div class="container-fluid">
  <div class="p-t-30">
    <div class="row">
      <div class="col-sm-12">
        <div class="card">
          <div class="card-header">
            <h5 class="card-header-text"><%= @user.name %></h5>
            <br />
            <br />

            <ol class="breadcrumb breadcrumb-title breadcrumb-arrow">
              <li class="breadcrumb-item"><i class="icofont icofont-home"></i></li>
              <li class="breadcrumb-item">Edit User</li>
            </ol>
          </div>

          <div class="p-l-20 p-r-20 p-b-20 p-t-20">
            <%= form_for @user, url: manager_user_path , html: {class: "wizard clearfix", method: 'PUT'} do |f| %>
            
              <%= f.error_messages %>
              <div class="md-group-add-on">
                <span class="md-add-on">
                  <i class="icofont icofont-ui-user"></i>
                </span>
                <div class="md-input-wrapper">
                  <%=f.text_field :name, class: 'md-form-control' %>
                  <%=f.label :name %>
                </div>
              </div>

              <div class="md-group-add-on">
                <span class="md-add-on">
                  <i class="icofont icofont-ui-email"></i>
                </span>
                <div class="md-input-wrapper">
                  <%=f.email_field :email, class: 'md-form-control' %>
                  <%=f.label :email %>
                </div>
              </div>

              <div class="md-group-add-on">
                <span class="md-add-on">
                  <i class="icofont icofont-key"></i>
                </span>
                <div class="md-input-wrapper">
                  <%=f.password_field :password, class: 'md-form-control' %>
                  <%=f.label :password %>
                </div>
              </div>

              <div class="md-group-add-on">
                <span class="md-add-on">
                  <i class="icofont icofont-key"></i>
                </span>
                <div class="md-input-wrapper">
                  <%=f.password_field :password_confirmation, class: 'md-form-control' %>
                  <%=f.label :password_confirmation %>
                </div>
              </div>
              
              <div class="md-group-add-on">
                <span class="md-add-on">
                  <i class="icofont icofont-funky-man"></i>
                </span>
                <div class="md-input-wrapper">
                  <%=f.select :role, options_for_select(User::ROLES.collect{|k, v| [v, k]}, selected: f.object.role), {}, class: 'md-form-control md-static' %>
                  <%=f.label :role %>
                </div>
              </div>

              <div class="text-center">
                <%= f.submit "update", class: "btn btn-primary" %>
                <%= link_to 'Cancel', manager_users_path, class: "btn btn-primary" %>
              </div>

            <% end %>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
  
            

            

app/views/manager/users/index.html.erb
<div class="container-fluid">
  <div class="p-t-30">
    <div class="row">
      <div class="col-sm-12">
        <div class="card">
        
          <div class="card-header">
            <h5 class="card-header-text"> Add/Manage Users </h5>
            <br />
            <br />
            <ol class="breadcrumb breadcrumb-title breadcrumb-arrow">
              <li class="breadcrumb-item"><i class="icofont icofont-home"></i></li>
              <li class="breadcrumb-item">Add User</li>
            </ol>
          </div>

          <div class="card">
              <div class="card-block text-center">
                <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#sign-in-up">Add User</button>
              </div>
          </div>

          <% if @users.present? %>
            <div class="table-content p-l-20 p-r-20 p-b-20">
                <table class="table table-striped photo-table">
                  <thead>
                    <tr role="row">
                      <th width=10></th>
                      <th> Name </th>
                      <th> Email Address </th>
                      <th> Role </th>
                      <th width=200> Created Date </th>
                      <th>Edit</th>
                      <th>delete</th>
                    </tr>
                  </thead>
                  <tbody>
                    <% @users.each do |user| %>
                    <tr>
                      <td><%= image_tag user.photo.url, class: 'media-object' %></td>
                      <td><%= user.name %></td>
                      <td><%= user.email %></td>
                      <td><%= User::ROLES[user.role] %></td>
                      <td><%= user.created_at.strftime TIME_FORMAT1 %></td>
                      <td><%= link_to edit_manager_user_path(user) do %> <i class="icofont icofont-edit"></i><% end %></td>
                      <td>
                    <%= link_to manager_user_path(user),style: 'color:#373a3c;position: relative;z-index: 1;',  method: :delete, data: { confirm: "You sure?"  } do %>
                    <i class="icofont icofont-ui-delete"></i><% end %></td>
                    </tr>
                  <% end %>
                  </tbody>
                </table>
              </div>
            <% else %>
              <div class="card-header">
                <center class="p-t-50 p-b-50">
                  Sorry you don't have any Users
                  <br />
                  <br />
                 
                </center>
              </div>
          <% end %>
        </div>
      </div>
    </div>
  </div>

  <div class="modal fade modal-flex" id="sign-in-up" tabindex="-1" role="dialog">
    <div class="modal-dialog">
      <div class="modal-content">
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>

        <div class="sign-in-up">
          <div class="sign-in-up-left"><i class="icofont icofont-users f-64" aria-hidden="true"></i>
          </div>
          <div class="sign-in-up-right">
            <%= render 'manager/users/new' %>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>

app/views/manager/users/new.html.erb
<div class="container-fluid">
  <div class="p-t-30">
    <div class="row">
      <div class="col-sm-12">
        <div class="card">
          <div class="p-l-20 p-r-20 p-b-20">
            <%= render 'manager/users/new' %>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>